<?php
require 'AbstractUIGenerator.php';
require 'ActionQuantik.php';
require 'ArrayPieceQuantik.php';
require 'PieceQuantik.php';
require 'PlateauQuantik.php';
require 'Player.php';
require 'QuantikGame.php';
require 'QuantikUIGenerator.php';
require_once 'PDOQuantik.php';
ini_set('display_errors', 1);
ini_set('error_reporting', E_ALL);
function getPageHome(): string
{
    require_once 'db.php';
    PDOQuantik::initPDO($_ENV['sgbd'], $_ENV['host'], $_ENV['database'], $_ENV['user'], $_ENV['password']);
    $allGames = PDOQuantik::getAllGameQuantik();
    $allPlayerGames = PDOQuantik::getAllGameQuantikByPlayerName($_SESSION['player']->name);
    $page = '<!DOCTYPE html>
<html class="no-js" lang="fr" dir="ltr">
  <head>
    <meta charset="utf-8" />
    <meta name="Author" content="Adrien et le BG" />
    <link rel="stylesheet" href="css/quantik.css"/>
    <title>Home</title>
  </head>
  <body>
  <div class="titreContainer"><h1>Quantik Game</h1></div>
     <div class="contentContainer"> 

   <div class="container"> <h2>Créer une partie</h2>
       <form action="traitementV2.php" method="post">
            <button class="largeButton" type="submit" name="action" value="creerPartie">+</button>
       </form>
   </div>
   <div class="container"> <h2>Continuer une partie</h2>';
    foreach ($allPlayerGames as $game) {
        if ($game['gamestatus'] === 'waitingForPlayer') {
            $data = json_decode($game['json']);
            $playeroneName = $data->couleursPlayers[$data->currentPlayer]->name;
            $page .= '<form class="formHome" action="traitementV2.php" method="post"> <span>En attente de: '.$playeroneName.'</span>';
            $page .= '<input type="hidden" name="gameid" value="'.$game['gameid'].'>"</input>';
            $page .= '<button class="smallButton" type="submit" name="action" value="continuerPartie"> > </button></form>';
        }
    }
   $page.='</div>
   <div class="container"> <h2>Rejoindre une partie</h2>';

    foreach ($allGames as $game) {
        if ($game['gamestatus'] === 'constructed' && $game['playerone'] !== $_SESSION['player']->id) {
            $data = json_decode($game['json']);
            $playeroneName = $data->couleursPlayers[0]->name;
            $page .= '<form class="formHome" action="traitementV2.php" method="post"> <span>Partie créée par: '.$playeroneName."</span>";
            $page .= '<input type="hidden" name="gameid" value="'.$game['gameid'].'>"</input>';
            $page .= '<button class="smallButton" type="submit" name="action" value="rejoindrePartie"> > </button></form>';
        }
    }
    $page .= '</div> <div class="container"> <h2>Consulter une partie terminée</h2>';
    foreach ($allGames as $game) {
        if ($game['gamestatus'] === 'finished') {
            $data = json_decode($game['json']);
            $nomGagnant = $data->couleursPlayers[$data->currentPlayer]->name;
            $page .= '<form class="formHome" action="traitementV2.php" method="post"> <span>Partie gagnée par: '.$nomGagnant."</span> ";
            $page .= '<input type="hidden" name="gameid" value="'.$game['gameid'].'>"</input>';
            $page .= '<button class="smallButton" type="submit" name="action" value="continuerPartie"> > </button></form>';
        }
    }
   $page.='</div >     
    <div class="container"> <h2> Quitter</h2>
       <form action = "traitementV2.php" method = "post" >
            <button class="largeButton" type = "submit" name = "action" value ="quitter">x</button>
       </form>
   </div>  </div>    
  </body>
</html> ';
    return $page;
}


session_start();
//print_r($_SESSION);
//print_r($_POST);
if (!isset($_SESSION['player'])) {
    header('Location: login.php');
}
switch ($_SESSION['etat']) {
    case 'home':
        echo getPageHome();
        break;

    case 'choixPiece':
        echo QuantikUIGenerator::getPageSelectionPiece($_SESSION["game"], $_SESSION["game"]->currentPlayer);
        break;

    case 'posePiece':
        echo QuantikUIGenerator::getPagePosePiece($_SESSION["game"],$_SESSION["game"]->currentPlayer,intval($_SESSION["piece"]));
        break;

    case 'consulterPartieVictoire':
        echo QuantikUIGenerator::getPageVictoire($_SESSION['game'], $_SESSION['game']->currentPlayer);
        break;

    case 'consulterPartieEnCours':
        $json = $_SESSION['game']->getJson();
        $data = json_decode($json);
        $playerName = $data->couleursPlayers[$_SESSION['game']->currentPlayer]->name;

        echo QuantikUIGenerator::getPageConsulter($_SESSION['game'],$playerName);
        break;

    default:
        $_SESSION['etat'] = 'home';
        echo QuantikUIGenerator::getPageErreur("Une erreur est survenue", "indext.php");
        break;

}
